#!/bin/bash

#ENVIRONMENT
SYNOINDEX=/usr/syno/bin/synoindex

#updateIndex [table] [path] [pattern]

  #1. indexing directory
  
  queryDirPath="select path from directory where path like '$2%'"
  queryDirCnt="select count(path) from directory"
  
  #remove deleted dir from db
  
  db=$(psql -U postgres -d mediaserver -c "$queryDirPath" | grep '/' | grep -v "@eaDir")
#  echo db:: "$db" >> /opt/log.txt
  
  while read line
  do
    query_paths=`echo $line | sed s/\'/"\\\\\'"/g`
	dir_paths=`echo $line | sed s/\'/"\\\'"/g`
    if [ ! -d "$query_paths" ] || [ "$(find $dir_paths -regex "$3")" == "" ]; then
        $SYNOINDEX -D "$query_paths"
        echo [DEL:D] $query_paths
    fi
  done <<< "$db"
  
  
  #add dir to db
  dirs=$(find "$2" -type d | grep -v "@eaDir")
#  echo dirs:: $dirs >> /opt/log.txt  
  while read line
  do
	query_paths=`echo $line | sed s/\'/"\\\\\'"/g`
    dir_paths=`echo $line | sed s/\'/"\\\'"/g`
    count=$(psql -U postgres -d mediaserver -c "$queryDirCnt where path = '$query_paths'")
  #  echo $count
    if [ "$(echo "$count" | grep " 1 ")" == "" ] && [ "$(find "$dir_paths" -regex "$3")" != "" ]; then
      $SYNOINDEX -A "$query_paths"    
      echo [ADD:D] $query_paths 
    fi
  done <<< "$dirs"
  
    
  #2. indexing files
  
  queryPath="select path from $1 where path like '$2%'"
  queryCnt="select count(path) from $1"
  
  #remove deleted file from db
  
  db=$(psql -U postgres -d mediaserver -c "$queryPath" | grep '/' | grep -v "@eaDir")
#  echo $db >> /opt/log.txt
  
  while read line
  do
	query_paths=`echo $line | sed s/\'/"\\\\\'"/g`
    dir_paths=`echo $line | sed s/\'/"\\\'"/g`
    if [ ! -e "$query_paths" ]; then
      $SYNOINDEX -d "$query_paths"
      echo [DEL:F] "$query_paths" 
    fi
  done <<< "$db"
  
  
  
  #add file to db
  
  files=$(find "$2" -regex "$3" | grep -v "@eaDir")
#  echo "$files" >> /opt/log.txt
  while read line
  do
    query_paths=`echo $line | sed s/\'/"\\\\\'"/g`
    dir_paths=`echo $line | sed s/\'/"\\\'"/g`
    count=$(psql -U postgres -d mediaserver -c "$queryCnt where path = '$query_paths'")
  #  echo $count
    if [ "$(echo $count | grep " 1 ")" == "" ]; then
     $SYNOINDEX -a $query_paths
      echo [ADD:F] $query_paths
    fi
  done <<< "$files"

#echo $(who) >> /opt/log.txt





